# PS2_1.py -- template for task #1
import PS2_tests

# this routine simply samples periodically and does not
# do adaptation using the transitions.
def naive_data_recovery(digitized_samples,samples_per_bit):
    l = len(digitized_samples)
    result = []  # accumulate message bits here

    # start in middle of first message bit
    index = samples_per_bit/2

    # iterate through samples until end
    while index < l:
        current = digitized_samples[index]
        result.append(current)
        # move to middle of next bit
        index += samples_per_bit

    return result

# return sequence of message bits given sequence of received
# digitized samples and the number of samples transmitted
# for each bit.  Handle the case where the receiver's clock
# is slightly faster or slower than the transmitter's.
def data_recovery(digitized_samples,samples_per_bit):
    l = len(digitized_samples)
    result = []  # accumulate message bits here

    # start in start
    index = 0
    print 'samples'
    print samples_per_bit
    # iterate through samples until end
    while index < l - samples_per_bit:
        first = digitized_samples[index]
        middle = digitized_samples[index+(samples_per_bit/2)-1]
        end = digitized_samples[index+samples_per_bit-1]

        #specs say just append here
        result.append(middle)
        #print middle

        #print digitized_samples[index]
        #print digitized_samples[index+1]
        #print digitized_samples[index+2]
        #print digitized_samples[index+3]
        #print digitized_samples[index+4]
        #print digitized_samples[index+5]
        #print digitized_samples[index+6]
        #print digitized_samples[index+7]

        #check for transition
        if first != end:
            #check where we are
            # move to the next bit
            #print 'first '+str(first)
            #print 'middle '+str(middle)
            #print 'end '+str(end)
            if middle == end:
                #print 'move down'
                index += samples_per_bit+1
            else: #middle != end:
                #print 'move up'
                index += samples_per_bit-1  
        else: #no transition
            #print 'no trans'
            index += samples_per_bit

    #get last bit
    result.append(digitized_samples[l-1])

    return result


# testing code.  Do it this way so we can import this file
# and use its functions without also running the test code.
if __name__ == '__main__':
    # which function to test.  Change this to point to
    # data_recovery when your code is ready to test.
    #ftest = naive_data_recovery
    ftest = data_recovery

    # start with a short test, no clock drift
    PS2_tests.task1_test(ftest,'same',debug=True,nbits=16)

    # clocks are drifting
    PS2_tests.task1_test(ftest,'fast')
    PS2_tests.task1_test(ftest,'slow')
