# this is the template for PSet #4, Python Task #1
import numpy
import PS4_tests

def sample_stats(samples,samples_per_bit=4,vth=0.5):
    # reshape array into samples_per_bit columns by as many
    # rows as we need.  Each column represents one of the
    # sample times in a bit cell.
    bins = numpy.reshape(numpy.array(samples),
                         (-1,samples_per_bit))

    #print samples
    #for i in samples:
        #print i

    
    # now compute statistics each column
    stats = []
    for i in xrange(samples_per_bit):
        print i
        column = bins[:,i]
        print column
        dist = abs(column - vth)  # subtract vth from each sample
        # Note that vth is the mean of the samples
        min_dist = numpy.min(dist)
        avg_dist = numpy.ma.average(dist)
        std_dist = numpy.std(dist)
        stats.append((min_dist,avg_dist,std_dist))

    return stats  # return collected statistics

if __name__ == '__main__':
    PS4_tests.test_sample_stats(sample_stats)

    stats = sample_stats(PS4_tests.noisy_channel_data)
    for i in xrange(len(stats)):
        min,avg,std = stats[i]
        print "sample %d: min_dist=%6.3f, avg_dist=%6.3f, " \
              "std_dist=%6.3f" % (i,min,avg,std)
