from PS7_1 import frequency_domain
import matplotlib.pyplot as p
import PS7_tests
import math

def detect_dialed_number(samples):
	print '======'
	a = frequency_domain(samples)

	N = len(samples)
	k = -math.floor(N/2)
	kcount = 0
	akhit = []

	for ak in a:
		if ak > .20:
			print ak
			print k
			#print kcount
			print k*16
			akhit.append(k*16)
		k = k+1
		kcount = kcount+1

	#check
	if (is_in(688,akhit) and is_in(1200,akhit)):
		print 'dial 1'
		return 1
	elif (is_in(688,akhit) and is_in(1328,akhit)):
		print 'dial 2'
		return 2
	elif (is_in(688,akhit) and is_in(1472,akhit)):
		print 'dial 3'
		return 3
	elif (is_in(768,akhit) and is_in(1200,akhit)):
		print 'dial 4'
		return 4
	elif (is_in(768,akhit) and is_in(1328,akhit)):
		print 'dial 5'
		return 5
	elif (is_in(768,akhit) and is_in(1472,akhit)):
		print 'dial 6'
		return 6
	elif (is_in(848,akhit) and is_in(1200,akhit)):
		print 'dial 7'
		return 7
	elif (is_in(848,akhit) and is_in(1328,akhit)):
		print 'dial 8'
		return 8
	elif (is_in(848,akhit) and is_in(1472,akhit)):
		print 'dial 9'
		return 9	
	elif (is_in(928,akhit) and is_in(1200,akhit)):
		print 'dial *'
		return '*'
	elif (is_in(928,akhit) and is_in(1328,akhit)):
		print 'dial 0'
		return 0
	elif (is_in(928,akhit) and is_in(1472,akhit)):
		print 'dial #'
		return '#'

	# enable to see what signal spectrum looks like
	PS7_tests.plot_spectrum(a)
	p.show()

    	


def is_in(value,table):
	for i in table:
		if i == value:
			return True



if __name__ == '__main__':
    samples = PS7_tests.read_wav_file('PS7_dtmf.wav')

    tone_samples = 500  # number of samples/digit
    index = 0   # where we are in processing samples
    dialed_number = []

    while (index + tone_samples) <= len(samples):
        # another dialing digit to process
        digit_samples = samples[index:index+tone_samples]

        # see what next dialed number is
        dialed_number.append(detect_dialed_number(digit_samples))

        # skip over samples for this digit and following
        # silence
        index += 2*tone_samples

	print dialed_number
