# template for PSet #4, Task #3
import PS4_tests
import numpy
 
# return data portion of codeword (nrows*ncols bits) with errors
# corrected.  If uncorrectable error, return raw bits.  codeword
# is a binary sequence that starts with the data row-by-row,
# followed by row parity bits, followed by column parity bits.
def correct_errors(codeword,nrows,ncols):
    print '===================================='
    # the raw data bits
    data = codeword[0:nrows*ncols]
    print codeword
    
 
    # do row & column parity checks, correct indicated error
    #chop off col parity bits
    print 'nrows '+str(nrows)
    row_parity = codeword[len(codeword)-ncols-nrows:len(codeword)-ncols]
    print row_parity
    print 'ncols '+str(ncols)
    col_parity = codeword[len(codeword)-ncols:len(codeword)]
    print col_parity


    #for each row
    badrows = []
    for i in xrange(nrows):
        start = (i)*ncols
        end = (i+1)*ncols
        print start
        print end
        row = data[start:end]
        print row
        row.append(row_parity[i])
        print row
        
        if not(PS4_tests.even_parity(row)):
            badrows.append(i)

    #for each col
    badcols = []
    for i in xrange(ncols):
        print 'col '+str(i)
        bins = numpy.reshape(numpy.array(data), (-1,ncols))
        col = bins[:,i]
        col = col.tolist() #that sill numpy.ndarray still won't append
        print col
        col.append(col_parity[i])
        print col
        
        if not(PS4_tests.even_parity(col)):
            badcols.append(i)

    print 'badrows'
    print badrows
    print 'badcols'
    print badcols
    

    #if a badrow and badcol need to fix
    if len(badrows) == 0 and len(badcols) == 0:
        #good message
        return data
    if len(badrows) == 1 ^ len(badcols) == 1: #XOR
        #error in parity; return message
        return data
    if len(badrows) > 1 or len(badcols) > 1:
        print 'error, can only fix one error'
        return data #specs say to do this
    if len(badrows) == 1 and len(badcols) == 1:
        #go to that bit and flip it
        position = ncols * badrows[0] + badcols[0]
        print 'fixing bit error at ('+str(badrows[0])+','+str(badcols[0])+'), position: '+str(position)
        if data[position] == 0:
            print 'was 0, now 1'
            data[position] = 1
        else:
            print 'was 1, now 0'
            data[position] = 0
        return data
        
        
    # return the posibly corrected data
    return data

if __name__ == '__main__':
    PS4_tests.test_correct_errors(correct_errors)
